
/**
 * <p>berschrift: </p>
 * <p>Beschreibung: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Organisation: </p>
 * @author Eugen Mller
 * @version 1.9
 */

/** Diese Klasse beinhaltet grundlegende Kommandos, welche von den
 * Player-klassen aufgerufen werde koennen. Mit Hilfe des CommunicationChannel
 * werden die Kommandos an den Server weitergeleitet.
 */

import java.lang.Math.*;
import java.util.*;
public class Actor
{
      // Deklaration eines Attributs von der Klasse CommunicationChannel
      CommunicationChannel cc;
      Player player;
      String TeamName;
    //Hier werden events zwischengespeichert falls eine Aktion sich aus mehreren Kommandos zusammensetzt
    Vector tempEvent=new Vector();
      public Actor(Player player)
      {

            this.player=player;
      }
      // Konstruktor Actor
      public Actor(Player player, String host, int port)
      {
            this.player=player;
            cc = new CommunicationChannel (host, port);
            //this.cc = cc;
      }
      // Ende Konstruktor

      // Initialisierung eines Teams bei dem Server
      public void init(String teamName)
      {
          TeamName = teamName;
	  String s, token;
  StringTokenizer st;
	  cc.send(new String("(init " + teamName + "(version 7.0))"));
	  s=cc.receive();
	  //s=cc.receive();
	  System.out.println("Actor: Init: "+s);
	  st=new StringTokenizer(s);
	  token=st.nextToken();
	  token=st.nextToken();
	  this.player.setDirection(token.startsWith("l"));
	  /*	  if (token.startsWith("l")) this.player.setDirection(true);
		  else this.player.setDirection(false);*/
      }
      public void initGoalie(String teamName)
      {
          TeamName = teamName;
	  String s, token;
  StringTokenizer st;
	  cc.send(new String("(init " + teamName + "(version 7.0) (goalie))"));
	  s=cc.receive();
	  //s=cc.receive();
	  System.out.println("Actor: Init: "+s);
	  st=new StringTokenizer(s);
	  token=st.nextToken();
	  token=st.nextToken();
	  this.player.setDirection(token.startsWith("l"));
	  /*	  if (token.startsWith("l")) this.player.setDirection(true);
		  else this.player.setDirection(false);*/
      }

      //Aufnahme der ankommenden Informationen von dem Server. Deren Klassifizierung
      //und Repraesentierung. Weiterleitung der erfassten Informationen an die Klasse Event.
      public Event event()
      {
            String m;

	    //Wenn noch ein temporrer Event besteht wird dieser gelscht und zurckgegeben
	    if (tempEvent.size()!=0){
		return (Event)tempEvent.remove(0);
	    }

            Event event = null;
	     while(event == null)
            {
                  m = cc.receive();
                if(m.startsWith("(see")||m.startsWith("(sense_body")||m.startsWith("(hear"))
                  {
                        event = new Event(m);
                  }

	          }
            return event;
	    }

    //Die Methode macht das gleiche wie die Event() MEthode nur das sie nicht auf temporre Events berprft
    public Event privEvent(){
	String m;
	while(true)
            {
		m = cc.receive();
                if(m.startsWith("(see")||m.startsWith("(sense_body")||m.startsWith("(hear"))
		    return new Event(m);
	    }
    }


      //Deklaration von Methode Bewegen zum Ball
      public void runToBall()
      {
	    //Deklaration von Koodination des Balls
            int x,y, mex, mey, oldx, oldy;
            x=player.ball.x;
            y=player.ball.y;
            mex=player.me.x;
            mey=player.me.y;
            oldx=player.ballOld.x;
            oldy=player.ballOld.y;
            double direction = player.me.direction;
            double moment=richtung(x, y, mex, mey, direction);
            double power = 13 * strecke(x, y, mex, mey);
            // Power darf nicht grer als 100 sein!!
            if (power>100)
            {
                  power=100;
            }
           /* if (oldx != x && oldy != y)  //Falls der Ball sich bewegt hat
            {
                  double ball_bewegung=strecke(x, y, oldx, oldy);
                  if (ball_bewegung>10)   //Falls er sich stark bewegt hat
                  {
                        //Um so viel muss der Spieler ausweichen, falls der Ball
                        //sich stark bewegt
                        moment= moment+((moment-richtung(oldx, oldy, mex, mey, direction))*(strecke(x, y, mex, mey)/ball_bewegung));
                  }
            }*/
            //Koerper zum Ball drehen mit turn() und dash()
	    /*            cc.send(new String("(turn " + moment + ")"));
			  Event e=privEvent();
	    while(!e.getMessage().startsWith("(sense")){
		tempEvent.add(e);
		e=privEvent();
		}*/
            cc.send(new String("(dash " + power + ")"));
      }

      public void walkToPosition(int x, int y)
      {
            int mex, mey;
            mex=player.me.x;
            mey=player.me.y;
            double direction = player.me.direction;
            double moment=richtung(x, y, player.me.x, player.me.y, direction);
            double power = 10 * strecke(x, y, player.me.x, player.me.y);
            // Power darf nicht grer als 100 sein!!
            if (power>100)
            {
                  power=100;
            }
	    
            //Koerper in Richtung (x,y) mit turn()  bewegen und dash()
	    System.out.println("Actor: "+moment+" "+direction);
            cc.send(new String("(turn " + moment + ")"));

	    //Es werden solange Events eingelesen und einem Vektor hinzugefgt
	    //bis ein sense_body event erhalten wird.
	    Event e=privEvent();
	    while(!e.getMessage().startsWith("(sense")){
		tempEvent.add(e);
		e=privEvent();
	    }
	    System.out.println("Actor: dash:" + power);
            cc.send(new String("(dash " + power + ")"));
      }
      public void searchBall()
      {
            //dreht sich um 40 Grad um den Ball zu suchen
            double moment=40;
            cc.send(new String("(turn " + moment + ")"));
      }

      public void shootToGoal()
      {
          // VOLLE Kanne aufs Tor heit mit Maximumpower schieen!!!
            double power=100;

            double direction = richtung(52, 0, player.me.x, player.me.y, player.me.direction);
            cc.send(new String("(kick " + power + " " + direction + ")"));
      }

      public void shootToPosition(int x, int y)
      {
	    //Kick() Richtung (x,y)
            double power=10 * strecke(x, y, player.me.x, player.me.y);
            // Power darf nicht grer als 100 sein!!
            if (power>100)
            {
                  power=100;
            }
            double direction = richtung(x, y, player.me.x, player.me.y, player.me.direction );
            cc.send(new String("(kick " + power + " " + direction + ")"));
      }

      public void turnToBall()
      {
         
            cc.send(new String("(turn " + player.ball.direction + ")"));
      }

      public void moveToPosition(int x, int y)
      {
            cc.send(new String("(move " + x + " " + y + ")"));
      }
      public void fangDenBall(double d) {
        // versucht den Ball (welcher im Winkel ALPHA zu dem Goalie steht) zu fangen
        cc.send(new String("(catch " +d+")"));
       }

      public void callBallPosition()
      {

            cc.send(new String("(say BallX " + player.ball.x + " BallY " + player.ball.y + " )"));

      }
      //Actor.java
      // Berechnet die Strecke zwischen 2 Koordinatenpunkten aus.
      private double strecke(int x1, int y1, int x2, int y2)
      {
            return Math.sqrt(((x1-x2)*(x1-x2))+((y1-y2)*(y1-y2)));
      }

      // Berechnet die Richtung
      public double richtung(int x1, int y1, int x2, int y2, double direction)
      {
      	if ((x1-x2)!=0)
        {	double winkel = Math.atan((y1 - y2)/(x1 - x2))*180/Math.PI;
        	System.out.println("winkel in Richtung"+winkel);
	      if(x2>x1 && y2>y1)
      	  {
       	  	winkel = 180-winkel+direction;
	      	if(winkel >= 180){return 360-winkel;}
	      	else {return -winkel;}
	       	}
      	  else if(x2>x1 && y2<y1)
       	  {
	        	winkel = 180+winkel-direction;
	      	if(winkel >=180){return winkel-360;}
	      	else {return winkel;}
	      	}
           else if(y2==y1){
                  if(x2>x1)
                  {
                  	if(direction>=0){return 180-direction;}
                  	else {return -direction-180;}
                        }
                  else
                  {return -direction;}
                  	}
           else return Math.atan((y1 - y2)/(x1 - x2))*180/Math.PI-direction;
          }
            
           
	   else 
	   {
	   	if(y2<y1)
	   	{
	   		double winkel = 90-direction;
	   		if(winkel>180){return winkel-360;}
	   		else	  {return winkel;}
                        }
	   	else 
	   	{
	   		double winkel = -90-direction;
	   		if(winkel<-180){return 360+winkel;}
	   		else	 {return winkel;}
                        }
               }

      }

}




