/**
 * Element.java<br>
 *Die Klasse <code>Element</code> ist zum Speichern der verschiedenen, beweglichen Elemente des Spiels (Mitspieler, Ball,...).
 *
 *
 * @author <a href="mailto:unbequemecouch@web.de">Matthias Bernges</a>
 * @version 0.8
 */

;
public class Element extends java.lang.Object implements java.io.Serializable{
    /**
     *Die Zeit des <code>Elements</code> in Millisekunden
     *
     */
    public long time;
    /**
     *Der Typ des <code>Elements</code><br>
     *Dabei gilt folgende Tabelle<br>
     *0 Der Spieler selbst<br>
     *1 Der Ball<br>
     *2xx Ein Mitspieler wobei xx die Nummer des Spielers darstellt<br>
     *3xx Ein Gegenspieler wobei xx die Nummer des Spieler darstellt
     */
    public int type;
    /**Die x-Position des <code>Elements</code>*/
    public int x;
    /**Die y-Poition des <code>Elements</code>*/
    public int y;
    /**Der Winkel zum <code>Element</code>*/
    public double direction;
    /**
     *Generiert ein leeres <code>Element</code>
     */
    public Element (){}

    /**
     *Generiert ein <code>Element</code> mit den bergebenen Werten
     *
     *@param time Die Zeit als das Objekt gesehen wurde.
     *@param type Der Elementtyp
     *@param x Die X-Position des Elements
     *@param y Die Y-Position des Elements
     *@param direction Der Winkel zum Element
     */
    public Element(long time, int type, int x, int y, double direction){
	this.time=time;
	this.type=type;
	this.x=x;
	this.y=y;
	this.direction=direction;
    }

    /**
     *Generiert ein <code>Element</code> mit den bergebenen Werten und nimmt als Zeit die aktuelle Zeit
     *
     *@param type Der Elementtyp
     *@param x Die X-Position des Elements
     *@param y Die Y-Position des Elements
     *@param direction Der Winkel zum Element
     */

    public Element(int type, int x, int y, double direction){
	this.time=System.currentTimeMillis();
	this.type=type;
	this.x=x;
	this.y=y;
	this.direction=direction;
    }

    /**
     *Gibt das <code>Element</code> als String zurck
     *
     *@return Einen String der das <code>Element</code> beschreibt.
     */
    public String toString(){
	return ("type: "+this.type+"\ntime: "+this.time+"\nx: "+this.x+" y: "+this.y+"\ndirection: "+this.direction+"\n");
    }


}// Object
