/**
 * Player.java
 *
 *Die abstrakte Klasse von der Spieler mit verschiedenen Taktiken abgeleitet werden knnen
 *
 *
 * @author <a href="mailto:unbequemecouch@web.de">Matthias Bernges</a>
 * @version
 */

public abstract class Player extends java.lang.Thread{

    /**Das aktuelle Ballelement das der Spieler kennt*/
    public Element ball;
    /**Der eigene Spieler als Element*/
    public Element  me;
    /**Ein lters Ballelement*/
    public Element  ballOld;
    Actor actor;
    /**Das Weltbild des Spielers*/
    public World world;
    int defX;
    int defY;
    boolean direction;
    int mode;

    String TeamName, Host;
	int Port;
    /**
     *Generiert einen Spieler
     *@param X Die Standard X Position zu der der Spieler immer wieder zurckkehrt
     *@param Y Die Standard Y Position zu der der Spieler immer wieder zurckkehrt
     *@param Team Der Teamname zu dem der Spieler gehrt
     *@param Host Der Hostname des Servers
     *@param Port Der Portname des Servers
     */
    public Player (int X, int Y, String TeamName, String Host, int Port){
	actor=new Actor(this, Host, Port);
	world=new World(actor);
	this.defX=X;
	this.defY=Y;	
	this.TeamName=TeamName;
	this.Port=Port;
	this.Host=Host;
    }

    /**Gibt die Standard X Position des Spielers zurck
     *@return Die Standard X Position
     */
    public int getX(){
	return defX;
    }

    /**Gibt die Standard Y Position des Spielers zurck
     *@return Die Standard Y Position
     */
    public int getY(){
	return defY;
    }

    /**
     *Diese Methode muss berschrieben werden um das Verhalten des Spielers zu implementieren
     */
    public abstract void doSomething();

    /**
     *Gibt das Weltbild des Spielers zurck
     *@return Das Weltbild des Spielers
     */
    public World getWorld(){
	return world;
    }
    /**Gibt zurck in welche Richtung der Spiler spielt
     *@return true falls der Spieler von Links nach Rechts spielt sonst fales
     */
    public boolean getDirection(){
	return this.direction;
    }

    public void setPlaymode(String s){
	if (s.startsWith("goal_")) mode=0;
	else if (s.startsWith("before_")) mode=0;
	else if (s.startsWith("play_on")) mode=1;
	else if (s.startsWith("kick_in_r")){
	    if (direction) mode=2;
	    else mode=3;
	}
	else if (s.startsWith("kick_in_l")){
	    if(direction) mode=3;
	    else mode=2;
	}
	else if(s.startsWith("free_kick_r")){
	    if (direction) mode=4;
	    else mode=5;
	}
	else if(s.startsWith("free_kick_l")){
	    if (direction) mode=5;
	    else mode=4;
	}
	else if(s.startsWith("corner_kick_r")){
	    if(direction) mode=6;
	    else mode=7;
	}
	else if(s.startsWith("corner_kick_l")){
	    if (direction) mode=8;
	    else mode=9;
	}
       	else if (s.startsWith("goal_kick_r")){
	    if(direction)mode=10;
	    else mode=11;
	}
	else if(s.startsWith("goal_kick_l")){
	    if(direction)mode=11;
	    else mode=10;
	}
       	else if (s.startsWith("kick_off_r")){
	    if(direction)mode=12;
	    else mode=13;
	}
	else if(s.startsWith("kick_off_l")){
	    if(direction)mode=13;
	    else mode=12;
	}
	System.out.println("Player: Mode: "+mode);
    }

    public void setDirection(boolean direction){
	this.direction =direction;
    }

    /**
     *berschreibt die Methode <code>run</code> in  <code>java.lang.Thread</code> sie wird ausgefhrt wenn die <code>run()</code> aufgerufen wird.
     */
    public void run (){
	actor.init(TeamName);
	world.refresh();
    }


}// Player
