/**
 * Team.java
 *Klasse die ein Team von Spielern verwaltet, dabei wird eine festgelegte Anzahl an unterschidlichen Spielertypen generiert
 *
 *
 * @author <a href="mailto:unbequemecouch@web.de">Matthias Bernges</a>
 * @version
 */
import java.net.*;
import java.util.*;
import java.io.*;
public class Team {

    Player p[]=new Player[11];
    String TeamName="abc";
    String Host="localhost";
    int Port=6000;

    public static void main (String args[]){
	String TeamName="", Host="";
	int Port=0;
	if (args.length!=3){
	    System.out.println("Aufruf: java Team TEAMNAME HOST PORT");
	    System.exit(-1);
	}
	else {
	    TeamName=args[0];
	    Host=args[1];
	    try{
		Port=Integer.parseInt(args[2]);
	    }catch(NumberFormatException nfe){
		System.out.println("Aufruf: java Team TEAMNAME HOST PORT");
		System.exit(-1);
	    }
	}
	Team t=new Team(TeamName, Host, Port);
    }

    public Team(String TeamName, String Host, int Port){
	this.TeamName=TeamName;
	this.Host=Host;
	this.Port=Port;
	ServerSocket ss;
	try{
	    ss=new ServerSocket(7000);
	    Player p[]=new Player[11];
	    initTeam();
	    startTeam();
	    while(true){
		MonitorSocket ms;
		ms=new MonitorSocket(ss.accept(),this);
		System.out.println("Team: Connection accepted");   
		ms.start();
	    }
	}catch (IOException e){
	    System.err.print("Team: error: ");e.printStackTrace();
	}
	
    }
    
    public Vector getObjects(int i){
	return p[i].getWorld().getObjects();
    }

    void initTeam(){

	p[0]=new Storm(40,0,TeamName, Host, Port);
        p[1]=new Storm(20,15,TeamName, Host, Port);
        p[2]=new Storm(20,-15,TeamName, Host, Port);
        p[3]=new Middle(3,20,TeamName, Host, Port);
        p[4]=new Middle(-3,7,TeamName, Host, Port);
        p[5]=new Middle(2,-4,TeamName, Host, Port);
        p[6]=new Middle(-2,-20,TeamName, Host, Port);
	p[7]=new Goalie(-48,0,TeamName, Host, Port);
	p[8]=new Defensive(-30,15,TeamName, Host, Port);
	p[9]=new Defensive(-30,-15,TeamName, Host, Port);
        p[10]=new Defensive(-15,0,TeamName, Host, Port);
    }

    void startTeam(){
        for (int i=0;i<11;i++)
	    p[i].start();
    }

}// Team
